/** Capacities and features for a customized, unique build of
 * the synti2 software synthesizer.
 *
 * Exported by PatchBank.cxx - don't edit manually.
 */
#ifndef SYNTI2_CAPACITIES_DEFINED
#define SYNTI2_CAPACITIES_DEFINED

/* Capacities (numeric) */ 
#define NUM_CHANNELS        16  /*Number of channels (patches)*/
#define NUM_DELAY_LINES     2   /*Number of delay lines*/
#define NUM_OPERATORS       3   /*Number of operators/oscillators per channel*/
#define NUM_ENVS            3   /*Number of envelopes per channel*/
#define NUM_ENV_KNEES       4   /*Number of knees per envelope*/
#define NUM_MODULATORS      4   /*Number of controllable modulators per channel*/

/* Enabled (#define) features */ 
#define FEAT_APPLY_FM                  /*Use frequency modulation */
#define FEAT_APPLY_ADD                 /*Use addition (source mixing) */
#define FEAT_NOISE_SOURCE              /*Use noise source */
#define FEAT_PITCH_DETUNE              /*Enable detuning of operators */
#define FEAT_DELAY_LINES               /*Enable delay lines */
#define FEAT_OUTPUT_SQUASH             /*Squash function at output */
#define FEAT_RESET_PHASE               /*Enable phase reset on note-on */
#define FEAT_PITCH_ENVELOPE            /*Enable pitch envelopes */

#define IPAR_ACTIVE                    0
#define IPAR_PHASE                     1
#define IPAR_EAMP1                     2
#define IPAR_EAMP2                     3
#define IPAR_EAMP3                     4
#define IPAR_EAMPN                     5
#define IPAR_EPIT1                     6
#define IPAR_EPIT2                     7
#define IPAR_EPIT3                     8
#define IPAR_FMTO1                     9
#define IPAR_FMTO2                     10
#define IPAR_FMTO3                     11
#define IPAR_ADDTO1                    12
#define IPAR_ADDTO2                    13
#define IPAR_ADDTO3                    14
#define NUM_IPARS 15

#define FPAR_NULLTGT                   15
#define FPAR_MIXLEV                    16
#define FPAR_LV1                       17
#define FPAR_LV2                       18
#define FPAR_LV3                       19
#define FPAR_LVN                       20
#define FPAR_LVD                       21
#define FPAR_ENV1K1T                   22
#define FPAR_ENV1K1L                   23
#define FPAR_ENV1K2T                   24
#define FPAR_ENV1K2L                   25
#define FPAR_ENV1K3T                   26
#define FPAR_ENV1K3L                   27
#define FPAR_ENV1K4T                   28
#define FPAR_ENV1K4L                   29
#define FPAR_ENV2K1T                   30
#define FPAR_ENV2K1L                   31
#define FPAR_ENV2K2T                   32
#define FPAR_ENV2K2L                   33
#define FPAR_ENV2K3T                   34
#define FPAR_ENV2K3L                   35
#define FPAR_ENV2K4T                   36
#define FPAR_ENV2K4L                   37
#define FPAR_ENV3K1T                   38
#define FPAR_ENV3K1L                   39
#define FPAR_ENV3K2T                   40
#define FPAR_ENV3K2L                   41
#define FPAR_ENV3K3T                   42
#define FPAR_ENV3K3L                   43
#define FPAR_ENV3K4T                   44
#define FPAR_ENV3K4L                   45
#define FPAR_DT1                       46
#define FPAR_DT2                       47
#define FPAR_DT3                       48
#define FPAR_DINLV1                    49
#define FPAR_DINLV2                    50
#define FPAR_DLEN1                     51
#define FPAR_DLEN2                     52
#define FPAR_DLEV1                     53
#define FPAR_DLEV2                     54
#define NUM_FPARS 40

/* Constants that may depend on custom values: */
#define ENV_TRIGGER_STAGE (NUM_ENV_KNEES + 1)
#define ENV_RELEASE_STAGE 2
#define ENV_LOOP_STAGE 1
#define NUM_ENV_DATA (NUM_ENV_KNEES*2)

#endif
